// C Header File
// Created 28.11.02; 11:58:25

SYM_ENTRY *get_temp_entry(char *nom);
short check(char *str);
char *mk_nam(char *str);
char *mk_ptr(char *str, unsigned short taille);
SYM_ENTRY *get_entry(char *str);
void Sprite16_OR(short x,short y,short h,unsigned short* sprite,void* dest);
void Sprite16_AND(short x,short y,short h,unsigned short* sprite,void* dest);
void FloodFillMF(short x,
                 short y,
                 unsigned short shade,
                 void* dest);
void ScaleSprite16_OR(unsigned short *sprite,unsigned char *dest,short x0,short y0,short sizex,short sizey);

#ifdef DIALOGUES
void AttEnter()	{
	while(_keytest(RR_ENTER));
	while(!_keytest(RR_ENTER));
}

void Dial (const char *msg)	{
	short x=8, y=83, xx;
	const char *msg2;
	memset(GetPlane(0)+80*30,255,20*30);
	memset(GetPlane(1)+80*30,255,20*30);
	while(1)	{
		OSFreeTimer(USER_TIMER);
		OSRegisterTimer(USER_TIMER,1);
		if (!*msg)
			break;
		if (_keytest(RR_ESC))
			goto termine;
		if (*msg=='\n')
			goto saute_ligne;
		if (*msg=='\t')
			goto case_suivante;
		if (*msg==' ')	{
			xx=x;
			msg2=msg;
			while(1)	{
				msg2++;
				if (*msg2=='\t' || *msg2=='\n' || *msg2==' ')
					break;
				xx+=6;
				if (xx>150)
					goto saute_ligne;
			}
			msg++;
			x+=6;
			continue;
		}
		
		SetPlane(0);
		DrawChar(x,y,*msg,0);
		SetPlane(1);
		DrawChar(x,y,*msg,0);
		x+=6;
		if (x>150)	{
saute_ligne:
			y+=8;
			if (y>98)	{
case_suivante:
				AttEnter();
				memset(GetPlane(0)+80*30,255,20*30);
				memset(GetPlane(1)+80*30,255,20*30);
				y=83;
			}
			x=8;
		}
		msg++;
		while(!OSTimerExpired(USER_TIMER));
	}
	AttEnter();
termine:
	while(_keytest(RR_ESC));
	for (x=0;x<=1;x++)
		memset(GetPlane(x),0,LCD_SIZE);
}
#endif

inline void CopieEcran(char *dest, char *src)	{
	register char *ptr1, *ptr2;
	register short a,b;
	ptr1=dest+10*30;
	ptr2=src+10*30;
	for (a=0;a<80;a++)	{
		ptr1+=3;			//Centrage
		ptr2+=3;
		for (b=0;b<14;b++)	{
			*ptr1=*ptr2;
			ptr1++;
			ptr2++;
		}
		ptr1+=13;
		ptr2+=13;
	}
}

short Temp = 0, Num = 0 ;

#define CALC_TOUCHES Touches = _rowread(0xfffe)

#ifdef USE_TI89
	#define _HAUT			(Touches & 1)
	#define _GAUCHE		(Touches & 2)
	#define _BAS			(Touches & 4)
	#define _DROITE		(Touches & 8)
	#define _2ND			(Touches & 16)
	#define _SHIFT		(Touches & 32)
	#define _DIAMOND	(Touches & 64)
	#define _ALPHA		(Touches & 128)
#else
	touches[0] = i&1 ? '1' : '0' ;
	touches[1] = i&4 ? '1' : '0' ;
	touches[2] = i&2 ? '1' : '0' ;
	touches[3] = i&8 ? '1' : '0' ;
	touches[4] = i&16 ? '1' : '0' ;
	touches[5] = i&64 ? '1' : '0' ;
	touches[6] = i&32 ? '1' : '0' ;
	touches[7] = i&128 ? '1' : '0' ;
#endif

#define T_GAUCHE 337
#define T_DROITE 340
#define T_HAUT 338
#define T_BAS 344

short WaitKey()	{
	GKeyFlush();
	while (!kbhit())/* idle()*/;
	push_getkey();
	ESI argptr=top_estack;
	return GetIntArg(argptr);
}

SYM_ENTRY *get_temp_entry(char *nom)
{
	SYM_ENTRY *entry = DerefSym(FindSymInFolder(nom, TempFolderName(Temp))) ;
	
	while (*(--nom) != 0 && *nom != 92) ;
	return (entry != NULL && *nom != 92 ? entry : NULL) ;
}

unsigned short var_len(char *var)
{
	return (2+*(unsigned short*)var) ;
}

short check(char *str)
{
	SYM_ENTRY *entry = get_entry(str) ;
	
	if (entry != NULL && entry->flags.bits.archived != 0)
	{
		return EM_moveSymFromExtMem(mk_nam(str), HS_NULL) ;
	}
	return 1 ;
}

char *mk_nam(char *str)
{
	static char name[19] = {0} ;
	short len = strlen(str) ;
	
	if (len > 17) return NULL ;
	
	return strcpy(name+1, str)+len ;
}

SYM_ENTRY *get_entry(char *str)
{
	char *nom = mk_nam(str) ;
	SYM_ENTRY *entry = get_temp_entry(nom) ;
	
	if (entry != NULL) return entry ;
	return SymFindPtr(nom, 0) ;
}

char *mk_ptr(char *str, unsigned short taille)
{
	char *nom = mk_nam(str) ;
	SYM_ENTRY *entry = get_temp_entry(nom) ;

	if (check(str) == 0) return NULL ;

	entry = DerefSym(entry != NULL ? AddSymToFolder(nom, TempFolderName(Temp)) : SymAdd(nom)) ;
	if (entry == NULL) return NULL ;

	nom = (char*)HeapDeref(entry->handle = HeapAlloc(taille)) ;
	if (entry->handle == H_NULL) return NULL ;

	*(unsigned short*)nom = taille-2 ;

	return (nom+2) ;
}

char *get_ptr(SYM_ENTRY *entry)
{
	if (entry == NULL || entry->handle == H_NULL) return NULL ;
	return (char*)HeapDeref(entry->handle) ;
}

void Attend(unsigned long temps)	{
	temps*=100;
	unsigned long w;
	for (w=0;w<temps;w--) w+=2;
}

/*inline void DessImg1(register short x, register short y, register short gfno, register unsigned short *nam)	{
	register short a,b,h=16;								//h=la hauteur du sprite
	register unsigned short *ptr;
	if (x<-15 || x>159) return;
	if (y<1)	{
		nam+=1-y;
		h-=1-y;
		y=1;
	}
	if (y+h>92) h-=(y+h-92);
	if (x<0)	{
		x=240+x;
		y--;
	}
 	if (h<0) return;
	
	for (a=0;a<=1;a++)	{
		for (b=0;b<h;b++)	{
				ptr=(pEcran(a)+30*(b+y)+(x>>3));
				*ptr=*(nam+32*gfno+b+16*a);
		}
	}
}*/

#ifdef EDITEUR
void EditGfx(unsigned short *nam)	{
	short a, b, x=0,y=0, gfno=1, Idx,k, mode=1;
	unsigned short *ptr1, *ptr2;
	unsigned short *ptr;
	short OutilSel=0, Carre=0, CarX=0, CarY=0, plan;
	unsigned short pp1[18], pp0[18];									//Presse papiers
	SCR_RECT rect;
	unsigned short sauve_motif[32];									//Sauvegarde de scurit du motif
	unsigned short modifie=1;
	unsigned short mode_masque=0;
	
	memset(pp0,0,sizeof(pp0));
	memset(pp1,0,sizeof(pp1));
	
	avant_la_boucle:
	memset(GetPlane(0),0,LCD_SIZE);
	memset(GetPlane(1),0,LCD_SIZE);
	memcpy(sauve_motif,nam+32*gfno,32*sizeof(short));
	
	while(1)	{
		if (mode_masque)	{
			for (a=0;a<=1;a++)	{
				for (b=0;b<16;b++)	{
						ptr=(GetPlane(a)+30*b);
						*ptr=(*(nam+256*32+16*gfno+b))^0xffff;
				}
			}
		}
		else	{
			for (a=0;a<=1;a++)	{
				for (b=0;b<16;b++)	{
						ptr=(GetPlane(a)+30*b);
						*ptr=*(nam+32*gfno+b+16*a);
				}
			}
		}
		for (a=0;a<=1;a++)	{
			SetPlane(a);
			DrawLine(16,0,16,16,1);
			DrawLine(0,16,100,16,1);
			DrawLine(100,0,100,16,1);
			DrawPix(x,y,2);
		}
		
		printf_xy(20,0,"Curseur % 2i,% 2i",x,y);
		printf_xy(20,8,"Motif n % 3i ",gfno);
		if (Carre==1)	{
			if (OutilSel==1 || OutilSel==3 || OutilSel==4)
				DrawClipRect(MakeWinRect(CarX,CarY,x,y),ScrRect,A_XOR);
			else if (OutilSel==2)
				DrawLine(CarX,CarY,x,y,A_XOR);
		}
		k=0;
		
		affoutils:
		for (a=0;a<7;a++)	{
			Sprite16_OR(25+16*(a%5),30+16*(a/5),16,Outils+16*a,GetPlane(0));
			if (a==OutilSel)
				Sprite16_OR(25+16*(a%5),30+16*(a/5),16,Outils+16*a,GetPlane(1));
			else
				Sprite16_AND(25+16*(a%5),30+16*(a/5),16,MasqueStd,GetPlane(1));
		}
		if (k!=0)	goto seloutil;

		if (OutilSel==6)	{
			if (pp1[0]==0)	{									//Presse papier vide -> Rien  coller
				OutilSel=1;											//Slection de l'outil de slection
				continue;
			}
			rect=(SCR_RECT){{0,0,15,15}};
			SetPlane(1);
			BitmapPut(x,y,pp1,&rect,mode);
			SetPlane(0);
			BitmapPut(x,y,pp0,&rect,mode);
		}

		if (modifie)	{
			rect=(SCR_RECT){{160-32,0,159,31}};
			for (a=0;a<=1;a++)	{
				SetPlane(a);
				ScrRectFill(&rect,ScrRect,0);
				ScaleSprite16_OR(nam+32*gfno+16*a,GetPlane(a),160-32,0,32,32);
			}
			modifie=0;
		}
		
		k=ngetchx();

		if (mode_masque)	{
			for (a=0;a<=1;a++)	{
				for (b=0;b<16;b++)	{
						ptr=(GetPlane(a)+30*b);
						*ptr=(*(nam+256*32+16*gfno+b))^0xffff;
				}
			}
		}
		else	{
			for (a=0;a<=1;a++)	{
				for (b=0;b<16;b++)	{
						ptr=(GetPlane(a)+30*b);
						*ptr=*(nam+32*gfno+b+16*a);
				}
			}
		}
		
		if (k==KEY_F3)			{											//[CATALOG] == Afficher le masque
			mode_masque=1-mode_masque;
			continue;
		}
		
		if (k==KEY_MODE)	{
			Idx=0;
			memset(str,0,sizeof(str));
			while(1)	{
				printf_xy(0,92,"Changement mode: % 3s_",str);
				if (Idx>=3) break;
				k=WaitKey();
				if (k<48 || k>57) break;
				str[Idx++]=k;
			}
			if (k!=KEY_ESC)	{
				k=atoi(str);
				if (k>=1 && k<=255)
					mode=k;
			}
			goto avant_la_boucle;
		}
		
		if (k==KEY_F2)	{
			ptr1=nam+256*32+16*gfno;
			ptr2=nam+32*gfno;
			for (a=0;a<16;a++)
				*(ptr1++)=*(ptr2++);
			ptr1-=16;
 			for (a=0;a<16;a++)	{
				*(ptr1)|=*(ptr2++);
				*(ptr1++)^=0xffff;
			}
			continue;
		}
		
		if (k==278)													//Catalog==sauvegarde du motif
			memcpy(sauve_motif,nam+32*gfno,32*sizeof(short));
		if (k==151)		{											//2nd+Catalog==restauration du motif
			memcpy(nam+32*gfno,sauve_motif,32*sizeof(short));
			modifie=1;
			continue;
		}

		if (k==KEY_APPS)	{
			while(1)	{
				seloutil:
				k=ngetchx();
				if (k==KEY_RIGHT && OutilSel<6)				OutilSel++;
				if (k==KEY_LEFT && OutilSel>0)				OutilSel--;
				if (k==KEY_ENTER)											break;
				goto affoutils;
			}
			k=0;
		}
		
		if (k==24576)												//Copier
			OutilSel=1;
		if (k==16648)												//Coller
			OutilSel=6;
			
		if (k==KEY_ESC)	{
			if (Carre>=1)
				Carre=0;
			else
				break;
		}
		
		if (k==43 && gfno<254)	{
			gfno++;
			modifie=1;
			goto avant_la_boucle;
		}
		if (k==45 && gfno>1)	{
			gfno--;
			modifie=1;
			goto avant_la_boucle;
		}
		
		if (k==KEY_ENTER)	{
			//L'utilisateur va rentrer un numro de motif  diter
			Idx=0;
			memset(str,0,sizeof(str));
			while(1)	{
				printf_xy(20,8,"Motif n % 3s_",str);
				if (Idx>=3) break;
				k=WaitKey();
				if (k<48 || k>57) break;
				str[Idx++]=k;
			}
			if (k!=KEY_ESC)	{
				k=atoi(str);
				if (k>=1 && k<=254)
					gfno=k;
			}
			modifie=1;
			goto avant_la_boucle;
		}
		
		if (k==KEY_LEFT && x>0) 		x--;
		if (k==KEY_RIGHT && x<15) 	x++;
		if (k==KEY_UP && y>0) 			y--;
		if (k==KEY_DOWN && y<15) 		y++;

		if (k==KEY_LEFT+4096)				x=0;
		if (k==KEY_RIGHT+4096)			x=15;
		if (k==KEY_UP+4096)					y=0;
		if (k==KEY_DOWN+4096)				y=15;
		
		if (k>=48 && k<=51)	{
			a=k-48;
			modifie=1;
			if (OutilSel==0)	{																			//Crayon
				SetPlane(0);
				DrawPix(x,y,a%2);
				SetPlane(1);
				DrawPix(x,y,a/2);
			}
			else if (OutilSel>=1 && OutilSel<=4)	{	//Slection/Rectangle/Plein
				if (Carre==0)		{																			//Encore rien commenc
					Carre=1;
					CarX=x;
					CarY=y;
				}
				else		{																							//Terminer la slection
					Carre=0;
					SetPlane(0);
					rect=(SCR_RECT){{CarX,CarY,x,y}};
					if (OutilSel==1)	{
						BitmapGet(&rect,pp0);
						SetPlane(1);
						BitmapGet(&rect,pp1);
					}
					else if (OutilSel==2)	{
						DrawLine(CarX,CarY,x,y,a%2);
						SetPlane(1);
						DrawLine(CarX,CarY,x,y,a/2);
					}
					else if (OutilSel==3)	{
						DrawClipRect(MakeWinRect(CarX,CarY,x,y),ScrRect,a%2);
						SetPlane(1);
						DrawClipRect(MakeWinRect(CarX,CarY,x,y),ScrRect,a/2);
					}
					else if (OutilSel==4)	{
						ScrRectFill(&rect,ScrRect,a%2);
						SetPlane(1);
						ScrRectFill(&rect,ScrRect,a/2);
					}
				}
			}
			else if (OutilSel==5)		{																//Remplissage
				//a==0 -> Remplit le plan clair de blanc
				//a==1 -> Remplit le plan clair de noir
				//a==2 -> Remplit le plan fonc de blanc
				//a==3 -> Remplit le plan fonc de noir
				b=GetPix(x,y);
				SetPlane(1);
				b+=2*GetPix(x,y);
				plan=a/2;
				a=a%2;
				
				SetPlane(plan);
				if (a==0)	{
					rect=(SCR_RECT){{0,0,15,15}};
					ScrRectFill(&rect,ScrRect,2);
					FloodFillMF(x,y,65535,GetPlane(plan));
					ScrRectFill(&rect,ScrRect,2);
				}				
				if (a==1)
					FloodFillMF(x,y,65535,GetPlane(plan));
			}
			else if (OutilSel==6)	{
				rect=(SCR_RECT){{0,0,15,15}};
				SetPlane(1);
				BitmapPut(x,y,pp1,&rect,mode);
				SetPlane(0);
				BitmapPut(x,y,pp0,&rect,mode);
			}
		}
		if (mode_masque)	{
			for (b=0;b<16;b++)	{
						ptr=(GetPlane(1)+30*b);
						*(nam+256*32+16*gfno+b)=(*ptr)^0xffff;
			}
		}
		else	{
			for (a=0;a<=1;a++)	{
				for (b=0;b<16;b++)	{
						ptr=(GetPlane(a)+30*b);
						*(nam+32*gfno+b+16*a)=*ptr;
				}			//EndFor
			}			//EndFor
		}			//EndIf
	}			//EndWhile
}			//Fin: EditGfx
#endif

short AtTouche()	{
while (!kbhit());// idle();
push_getkey();
ESI argptr=top_estack;
return GetIntArg(argptr);
//return ngetchx();
}


#ifndef __GRAY
#define __GRAY

//Note: Les dfinitions proviennent directement du fichier gray.h vu que les fonctions sont similaires

/*--------------------------------------------------------------------------*/
/* PUBLIC SECTION                                                           */
/*--------------------------------------------------------------------------*/

/* Begin Auto-Generated Part */
#define GRAYDBUFFER_SIZE 7688
#ifndef __HAVE_Bool
#define __HAVE_Bool
enum Bool{FALSE,TRUE};
#endif
enum GrayModes{GRAY_OFF=0,GRAY_ON=1,GRAY_HW1=1,GRAY_HW2=1};
enum GrayPlanes{LIGHT_PLANE=0,DARK_PLANE=1};
#ifndef __HAVE_INT_HANDLER
#define __HAVE_INT_HANDLER
typedef struct{short foo;}_DEREF_INT_HANDLER,*INT_HANDLER;
#endif
#define GrayAdjust(x) ((void)(*(volatile unsigned char*)0x600013=128-(signed char)(x)))
#define GrayCheckRunning() (!!__gray_handle)
#define IsGrayMode GrayCheckRunning
#define GrayDBufCleanup() ((void)(__gray_dbl_offset=0,__D_plane2=__D_plane,__L_plane2=__L_plane))
#define GrayDBufGetActiveIdx() (!!__gray_dbl_offset)
#define GrayDBufGetActivePlane(x) (GrayDBufGetPlane(GrayDBufGetActiveIdx(),x))
#define GrayDBufGetHiddenIdx() (!__gray_dbl_offset)
#define GrayDBufGetHiddenPlane(x) (GrayDBufGetPlane(GrayDBufGetHiddenIdx(),x))
#define GrayDBufGetPlane(i,x) ((i)?((x)?__D_plane2:__L_plane2):GrayGetPlane(x))
#define GrayDBufInit(p) ({void*aptr=(void*)((((long)p)+7)&0xfffffff8L);__gray_dbl_offset=0;__D_plane2=aptr;(void)(__L_plane2=aptr+3840);})
#define GrayDBufSetActiveAMSPlane(x) GrayDBufSetAMSPlane(GrayDBufGetActiveIdx(),x)
#define GrayDBufSetActiveIdx(i) ((void)(__gray_dbl_offset=((i)?8:0)))
#define GrayDBufSetActiveIdxSync(i) ((void)(GrayWaitNSwitches(1),GrayDBufSetActiveIdx(i)))
#define GrayDBufSetAMSPlane(i,x) (_rom_call(void,(void*,long),1A2)(GrayDBufGetPlane(i,x),0xEF007F))
#define GrayDBufSetHiddenAMSPlane(x) GrayDBufSetAMSPlane(GrayDBufGetHiddenIdx(),x)
#define GrayDBufToggle() ((void)(__gray_dbl_offset=(__gray_dbl_offset?0:8)))
#define GrayDBufToggleSync() ({GrayWaitNSwitches(1);GrayDBufToggle();})
#define GrayGetInt1Handler() ((INT_HANDLER)(__gray_hw_type?__gray_old_int1_hw2:__gray_old_int1_hw1))
#define GetGrayInt1Handler GrayGetInt1Handler
#define GrayGetPlane(x) ((x)?__D_plane:__L_plane)
#define GetPlane GrayGetPlane
#define GrayGetSwitchCount() (__switch_cnt)
#define GetGraySwitchCount GrayGetSwitchCount
#define GrayGetVersionString() ((const char*)__gray_version)
#define GrayMode(x) ((x)?GrayOn():({GrayOff();(short)1;}))
extern void GrayOff(void)__ATTR_LIB_ASM__;
extern short GrayOn(void)__ATTR_LIB_ASM__;
extern void GrayOnThrow(void)__ATTR_LIB_ASM__;
#define GraySetAMSPlane(x) (_rom_call(void,(void*,long),1A2)(GrayGetPlane(x),0xEF007F))
#define SetPlane GraySetAMSPlane
#define GraySetInt1Handler(p) ((void)(__gray_hw_type?((INT_HANDLER)__gray_old_int1_hw2=(p)):((INT_HANDLER)__gray_old_int1_hw1=(p))))
#define SetGrayInt1Handler GraySetInt1Handler
#define GraySetSwitchCount(val) (__switch_cnt=(val))
#define SetGraySwitchCount GraySetSwitchCount
#define GrayWaitNSwitches(n) ({unsigned long __w=__switch_cnt+(n);while(__switch_cnt<__w);})
/* End Auto-Generated Part */

#define _GrayIsRealHW2() (__gray_hw_type)

#endif

#ifdef EDITEUR
short ControleEnTete(short xDep,short yDep,short typeNiv,short temps,short coulAP,short perso,
										 short eau)	{
		if (xDep<0 || xDep>=TABLE_X-1)
			return Erreur("xDep (en-tte) non-valide");
		if (yDep<0 || yDep>=TABLE_Y-1)
			return Erreur("yDep (en-tte) non-valide");
		if (typeNiv<0 || typeNiv>=10)
			return Erreur("typeNiv (en-tte) non-valide");
		if (temps<0 || temps>=1000/5)
			return Erreur("temps (en-tte) non-valide");
		if (coulAP<0 || coulAP>3)
			return Erreur("coulAP pas entre 0 et 3");
		if (perso!=GEN && perso!=LUNA)
			return Erreur("perso doit valoir 0 ou 1");
		if (eau<0)
			return Erreur("Niveau de l'eau non-valide");
		return 0;																						//OK
}
#else
short ControleEnTete(short xDep,short yDep,short typeNiv,short temps,short coulAP,short perso,
										 short eau)	{
		if (xDep<0 || xDep>=TABLE_X-1 || yDep<0 || yDep>=TABLE_Y-1 || typeNiv<0 || typeNiv>=10
		|| temps<0 || temps>=1000/5 || coulAP<0 || coulAP>2 || (perso!=GEN && perso!=LUNA) ||
		eau<0)
			return Erreur("En-tte non-valide");
		return 0;																						//OK
}
#endif

void SPRITE_16(short x,short y,short h,unsigned short* sprite,unsigned short* sprite1,unsigned short* sprite2,void* dest1, void *dest2)	{
		if (x<-15 || x>159) return;
		if (y<10)	{
		sprite+=10-y;
		sprite1+=10-y;
		sprite2+=10-y;
		h-=10-y;
		y=10;
		}
		if (y+h>92) h-=(y+h-92);
		if (x<0)	{
		x=240+x;
		y--;
		}
 		if (h<0) return;

	  register long            addr1 = (long)dest1+(y<<5)-(y<<1)+((x>>3)&0x1e);
	  register long            addr2 = (long)dest2+(y<<5)-(y<<1)+((x>>3)&0x1e);
    register unsigned short  cnt  = 16-(x&15);
    for (;h;h--,addr1+=30,addr2+=30)	{
    	//MASQUE
    	*(long*)addr1&=~((long)~((*sprite) & 0xffff)<<cnt);
    	*(long*)addr2&=~((long)~((*sprite++) & 0xffff)<<cnt);
			//AFFICHE
    	*(long*)addr1|=(long)((*sprite1++) & 0xffff)<<cnt;
    	*(long*)addr2|=(long)((*sprite2++) & 0xffff)<<cnt;
		}
}

void Sprite16_AFFICH(short x,short y,short h,unsigned short* sprite1,unsigned short* sprite2,void* dest1, void *dest2)	{
		if (x<-15 || x>159) return;
		if (y<10)	{
		sprite1+=10-y;
		sprite2+=10-y;
		h-=10-y;
		y=10;
		}
		if (y+h>92) h-=(y+h-92);
		if (x<0)	{
		x=240+x;
		y--;
		}
 		if (h<0) return;

	  register long            addr1 = (long)dest1+(y<<5)-(y<<1)+((x>>3)&0x1e);
	  register long            addr2 = (long)dest2+(y<<5)-(y<<1)+((x>>3)&0x1e);
    register unsigned short  cnt  = 16-(x&15);
    for (;h;h--,addr1+=30,addr2+=30)	{
    	*(long*)addr1|=(long)((*sprite1++) & 0xffff)<<cnt;
    	*(long*)addr2|=(long)((*sprite2++) & 0xffff)<<cnt;
		}
}

void Sprite16_OR(short x,short y,short h,unsigned short* sprite,void* dest) {
		if (x<-15 || x>159) return;
		if (y<10)	{
		sprite+=10-y;
		h-=10-y;
		y=10;
		}
		if (y+h>90) h-=(y+h-90);
		if (x<0)	{
		x=240+x;
		y--;
		}
 		if (h<0) return;
	  register long            addr = (long)dest+(y<<5)-(y<<1)+((x>>3)&0x1e);
    register unsigned short  cnt  = 16-(x&15);
    for (;h;h--,addr+=30) *(long*)addr|=(long)((*sprite++) & 0xffff)<<cnt;
}

void Sprite16_AND(short x,short y,short h,unsigned short* sprite,void* dest) {
		if (x<-15 || x>159) return;
		if (y<10)	{
		sprite+=10-y;
		h-=10-y;
		y=10;
		}
		if (y+h>90) h-=(y+h-90);
		if (x<0)	{
		x=240+x;
		y--;
		}
		if (h<0) return;

    register long           addr = (long)dest+(y<<5)-(y<<1)+((x>>3)&0x1e);
    register unsigned short cnt  = 16-(x&15);

    for (;h;h--,addr+=30) *(long*)addr&=~((long)~((*sprite++) & 0xffff)<<cnt);
}
//-----------------------------------------------------------------------------
// original code courtesy of Zeljko Juric
//-----------------------------------------------------------------------------
#define EXT_PIXOFFSET(x,y)  ((y<<5)-(y<<1)+(x>>3))
#define EXT_PIXADDR(p,x,y)  (((unsigned char*)(p))+EXT_PIXOFFSET(x,y))
#define EXT_PIXMASK(x)      ((unsigned char)(0x80 >> ((x)&7)))
#define EXT_GETPIX_AM(a,m)  (*(a) & (m))
#define EXT_GETPIX(p,x,y)   EXT_GETPIX_AM(EXT_PIXADDR(p,x,y),EXT_PIXMASK(x))

#define EXT_PIXLEFT_AM(a,m)   asm("rol.b  #1,%0;bcc.s  0f;subq.l #1,%1;0:"\
                                  : "=d" (m), "=g" (a) : "0" (m), "1" (a))
#define EXT_PIXRIGHT_AM(a,m)  asm("ror.b  #1,%0;bcc.s  0f;addq.l #1,%1;0:"\
                                  : "=d" (m), "=g" (a) : "0" (m), "1" (a))


#define STACKBORDER 1500    // stack shouldn't went down lower than this


#define PUSH(ENTRY) { unsigned long spvalue; \
  asm ("move.l %%sp,%0":"=g"(spvalue)); if(spvalue>STACKBORDER) { \
  sp++; asm volatile("move.l %0,-(%%sp);"::"g"(*(long*)ENTRY));}}

#define POP(ENTRY) {sp--; asm volatile("move.l (%%sp)+,(%0);"::"a"(&ENTRY));}

#ifdef EDITEUR
void FloodFillMF(short x,
                 short y,
                 unsigned short shade,
                 void* dest)
{
    short x1,x2,dy,l,i,sp=0;
    short xmax=LCD_WIDTH-1,ymax=LCD_HEIGHT-1;
    unsigned char entry[4],texture[4],*ybase,*addr,mask,tmask;
    long diff;
    void* tmpplane;

    if (x<0||x>xmax||y<0||y>ymax||(EXT_GETPIX(dest,x,y))) return;

    if (!(tmpplane = malloc(3840))) return;

    memcpy(tmpplane,dest,3840);
    diff=((unsigned char*)tmpplane)-(unsigned char*)dest;

    for (i=3;i>=0;i--) {
        tmask=shade&15;
        shade>>=4;
        texture[i]=tmask+(tmask<<4);
    }

    entry[0]=y;
    entry[1]=entry[2]=x;
    entry[3]=1;
    if(y<ymax) PUSH(entry);
    entry[0]++;
    entry[3]=-1;
    PUSH(entry);

    while (sp) {
        POP(entry);
        y=entry[0]+(dy=(signed char)entry[3]);
        x=x1=entry[1];
        x2=entry[2];
        entry[0]=y;
        tmask=texture[y&3];
        ybase=((unsigned char*)tmpplane)+(y<<5)-(y<<1);
        addr=ybase+(x>>3);
        mask=1<<(~x&7);

        while (x>=0&&!(*addr&mask)) {
            *addr|=mask; *(addr-diff)|=mask&tmask; x--;
            EXT_PIXLEFT_AM(addr,mask);
        }
        if (x>=x1) goto skip;
        l=x+1;
        if(l<x1&&y-dy>=0&&y-dy<=ymax) {
            entry[1]=l; entry[2]=x1-1; entry[3]=-dy;
            PUSH(entry);
        }

        x=x1+1;
        do {
            addr=ybase+(x>>3);
            mask=1<<(~x&7);
            while (x<=xmax&&!(*addr&mask)) {
                *addr|=mask;
                *(addr-diff)|=mask&tmask;
                x++;
                EXT_PIXRIGHT_AM(addr,mask);
            }
            entry[1]=l;
            entry[2]=x-1;
            entry[3]=dy;
            if (y+dy>=0&&y+dy<=ymax) PUSH(entry);
            if (x>x2+1&&y-dy>=0&&y-dy<=ymax) {
                entry[1]=x2+1; entry[3]=-dy;
                PUSH(entry);
            }
skip:       x++;
            addr=ybase+(x>>3);
            mask=1<<(~x&7);

            while(x<=x2&&*addr&mask) {
                x++;
                EXT_PIXRIGHT_AM(addr,mask);
            }
            l=x;
        }
        while(x<=x2);
    }

    free(tmpplane);
}

#define getpixel16(s,x,y)  (*((unsigned char *)(s)+((y)<<1)+((x)>>3)))&bit_table[(x)&7]


void ScaleSprite16_OR(unsigned short *sprite,unsigned char *dest,short x0,short y0,short sizex,short sizey) {
    short x,y;
    unsigned short u,v=0,du=(16<<8)/sizex,dv=(16<<8)/sizey,tempv;
    unsigned char *src,mask,tempx0=x0>>3,origmask=0x80>>(x0&7);
    static const unsigned char bit_table[8]={128,64,32,16,8,4,2,1};

    for (y=y0;y<y0+sizey;y++) {
        u=0;
        src=((unsigned char *)dest)+(y<<5)-(y<<1)+tempx0;
        mask=origmask;
        tempv=v>>8;
        for (x=0;x<sizex;x++) {
            if (getpixel16(sprite,u>>8,tempv)) *src|=mask;
            asm("ror.b #1,%0;bcc.s 0f;addq.l #1,%1;0:":"=d" (mask),"=g" (src):"0"(mask),"1"(src));
            u+=du;
        }
        v+=dv;
    }
}
#endif

// macro which exchanges the content of two variables using the ASM exg instruction
#define EXT_XCHG(a,b)    asm volatile ("exg %0,%1" : "=d" (a), "=d" (b) : "0" (a), "1" (b) : "cc")

// checks for collision between 2 sprites of width 16
// returns 1 if a collision is detected
short TestCollide16(short x0,short y0,short x1,short y1,
                    short height,unsigned short* data0, unsigned short* data1)
{
    short dx,dy,i,j,change;

    // sprite 0 is left of sprite 1 ...
    if (x0<x1) {
        dx = x1-x0;
        change=0;
    }
    else {
        // if sprite 0 is right of sprite 1 just exchange
        // all necessary variables so we can still assume
        // sprite 0 is left of sprite 1 ...
        dx = x0-x1;
        EXT_XCHG(data0,data1);
        EXT_XCHG(y0,y1);
        change=1;
    }

    if (dx>=16) return 0; // cannot overlap in this case (x difference too large)

    if (y0<y1) {
        dy = y1-y0;
        data0+=dy;
        if (change)	j=dy;
        else				j=0;
    }
    else {
        dy = y0-y1;
        data1+=dy;
        if (change)	j=0;
        else				j=dy;
    }
		
    for (i=dy;i<height;i++,data0++,data1++) {
   			j++;
        // Let's shift the data of sprite 0 to the left and AND it with
        // the data of sprite 1. If this results in at least one bit set,
        // we have a collision
        // Note: On utilise ici une version inverse du masque paysage de chaque "tile"
        if (((unsigned long)*data1) & (((unsigned long)*data0) << dx))	{
/* 						if (colPtr==0)						//Aucune collision jusqu' maintenant?
							collisions[colPtr++]=j/2;	//On stocke le rsultat
						else if (colPtr==1 && ((collisions[0]!=8 && j/2==8) || (collisions[0]==8 && j/2!=8)))
							collisions[colPtr++]=j/2;		//Une condition dj existante. La nouvelle ne sera stocke  la suite de l'ancienne que si elle ne dsigne pas la mme collision
						if (colPtr>=2)
							return 0;*/
						return j;
				}
   }
    // if we come here we have found no collision!
    return 0;
}

short GenTestCollide16(short x0,short y0,short x1,short y1,
                    short height,unsigned short* data0, unsigned short* data1, short colPtr)
{
    short dx,dy,i,j,change,meilleur,inferieur_a_huit=0;

    // sprite 0 is left of sprite 1 ...
    if (x0<x1) {
        dx = x1-x0;
        change=0;
    }
    else {
        // if sprite 0 is right of sprite 1 just exchange
        // all necessary variables so we can still assume
        // sprite 0 is left of sprite 1 ...
        dx = x0-x1;
        EXT_XCHG(data0,data1);
        EXT_XCHG(y0,y1);
        change=1;
    }

    if (dx>=16) return 0; // cannot overlap in this case (x difference too large)

    if (y0<y1) {
        dy = y1-y0;
        data0+=dy;
        if (change)	j=dy;
        else				j=0;
    }
    else {
        dy = y0-y1;
        data1+=dy;
        if (change)	j=0;
        else				j=dy;
    }

		meilleur=0;
    for (i=dy;i<height;i++,data0++,data1++) {
   			j++;
        // Let's shift the data of sprite 0 to the left and AND it with
        // the data of sprite 1. If this results in at least one bit set,
        // we have a collision
        // Note: On utilise ici une version inverse du masque paysage de chaque "tile"
        if (((unsigned long)*data1) & (((unsigned long)*data0) << dx))	{
        	meilleur=j;
        	if (j<8)
        		inferieur_a_huit++;
        }
    }

		if (meilleur==8 && inferieur_a_huit && !colPtr)
			meilleur=4;
	
    // if we come here we have found no collision!
    return meilleur;
}

#define BOUNDS_COLLIDE16(x0,y0,x1,y1)		(x1-x0>=-16 && x1-x0<=16 && y1-y0>=-16-haut && y1-y0<=16+haut)

unsigned char *  charset   = NULL;  //adresse des images des caractres (cf ci-dessous)
unsigned short * charwidth = NULL;		//longueur des caractres de petite police

//valeurs de font et font2 pour FastChar
#define POLICE_1 6,18
#define POLICE_2 8,10
#define POLICE_3 10,0

//Pour obtenir la largeur d'une chane de caractres
short largeurChn(unsigned char *chn)	{
	short taille=0;
	for (;*chn;chn++)
		taille+=charwidth[*chn];
	return taille;
}

//Routines de la TICT
static inline void SetupCharSet(void) {
		unsigned short i;

		// Little font
		FontSetSys(F_4x6);
		memset(charset,0,6*256+8*256+10*256);
		PortSet(charset+10*256+8*256,7,6*256-1);

		for (i=0;i<256;i++) {
				charwidth[i] = FontCharWidth(i);
				DrawChar(0,i*6,i,A_REPLACE);
		}

		// Medium font
		FontSetSys(F_6x8);
		PortSet(charset+10*256,7,8*256-1);

		for (i=0;i<256;i++)
				DrawChar(0,i<<3,i,A_REPLACE);

    // Big font
		FontSetSys(F_8x10);
		PortSet(charset,7,10*256-1);

		for (i=0;i<256;i++)
				DrawChar(0,i*10,i,A_REPLACE);

		FontSetSys(F_6x8);
		PortRestore();
}

//=======================================================================================================================
//=================================== Affiche une chaine de caractres (merci TICT!) ====================================
//=======================================================================================================================

void FastStr(short x,short y,const unsigned char *str,void *plane, short font, short font2) {
		unsigned char  * sprite;
		long           addr;
    long           addr_const = ((long)plane)+(y<<5)-(y<<1);
		unsigned short cnt;

		while (*str) {
				sprite=&charset[font2*256+((short)(*str))*font];
				addr = addr_const+((x>>3)&0xfffe);
				cnt  = 25-(x&15);
            // unrolled loop for more speed ...
				*(long*)addr^=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr^=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr^=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr^=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr^=(long)(*sprite++)<<cnt; addr+=30;
				*(long*)addr^=(long)(*sprite++)<<cnt;
				if (font!=6) {
						addr+=30;
						*(long*)addr^=(long)(*sprite++)<<cnt; addr+=30;
						*(long*)addr^=(long)(*sprite++)<<cnt;
						if (font==10) {
								addr+=30;
								*(long*)addr^=(long)(*sprite++)<<cnt; addr+=30;
								*(long*)addr^=(long)(*sprite++)<<cnt;
								x+=8;
						} else
								x+=6;
				} else
						x+=charwidth[(short)(*str)];
				str++;
		}

}

unsigned char alloc_screen(void) {

//allocation des mmoires pour les caractres + savescreen + vscreen
		if ((charset=malloc(10*256+8*256+6*256+2*256))==NULL)
				return 0;

		charwidth  = (unsigned short *)((void *)(charset+10*256+8*256+6*256));
		SetupCharSet();  //dessine les caractres

		return 1;
}

#define getpixel32(s,x,y)  (*((unsigned char *)(s)+((y)<<2)+((x)>>3)))&bit_table[(x)&7]

void ScaleSprite32_OR(unsigned long *sprite,unsigned char *dest,short x0,short y0,short sizex,short sizey) {
    short x,y;
    unsigned short u,v=0,du=(32<<8)/sizex,dv=(32<<8)/sizey,tempv;
    unsigned char *src,mask,tempx0=x0>>3,origmask=0x80>>(x0&7);
    static const unsigned char bit_table[8]={128,64,32,16,8,4,2,1};

    for (y=y0;y<y0+sizey;y++) {
    		if (y<10)	goto saute;
    		if (y>90)	return;
        u=0;
        src=((unsigned char *)dest)+(y<<5)-(y<<1)+tempx0;
        mask=origmask;
        tempv=v>>8;
        for (x=0;x<sizex;x++) {
            if (getpixel32(sprite,u>>8,tempv)) *src|=mask;
            asm("ror.b #1,%0;bcc.s 0f;addq.l #1,%1;0:":"=d" (mask),"=g" (src):"0"(mask),"1"(src));
            u+=du;
        }
        saute:
        v+=dv;
    }
}

void ScaleSprite32_AND(unsigned long *sprite,unsigned char *dest,short x0,short y0,short sizex,short sizey) {
    short x,y;
    unsigned short u,v=0,du=(32<<8)/sizex,dv=(32<<8)/sizey,tempv,pix32,pixscreen;
    unsigned char *src,mask,tempx0=x0>>3,origmask=0x80>>(x0&7);
    static const unsigned char bit_table[8]={128,64,32,16,8,4,2,1};

    for (y=y0;y<y0+sizey;y++) {
    		if (y<10)	goto saute;
    		if (y>90)	return;
        u=0;
        src=((unsigned char *)dest)+(y<<5)-(y<<1)+(tempx0);
        mask=origmask;
        tempv=v>>8;
        for (x=0;x<sizex;x++) {
            pix32=getpixel32(sprite,u>>8,tempv);
            pixscreen=*src&mask;

            if (pix32&&pixscreen) *src|=mask;
            else if (!pix32) *src&=~mask;
            asm("ror.b #1,%0;bcc.s 0f;addq.l #1,%1;0:":"=d" (mask),"=g" (src):"0"(mask),"1"(src));
            u+=du;
        }
        saute:
        v+=dv;
    }
}

void Sprite32_OR(short x,short y,short h,unsigned long* sprite,void* dest) {
		if (x<-31 || x>159) return;
		if (y<10)	{
		sprite+=10-y;
		h-=10-y;
		y=10;
		}
		if (y+h>90) h-=(y+h-90);
		if (x<0)	{
		x=240+x;
		y--;
		}
		if (h<0) return;
		
    register long           addr = (long)dest+(y<<5)-(y<<1)+((x>>3)&0x1e);
    register unsigned short cnt  = x&15;
    register unsigned short ccnt = 32-cnt;
    register unsigned long  data;
    for (;h;h--,addr+=30) {
        data=*sprite++;
        *(long*)addr|=(data>>cnt),*(long*)(addr+4)|=(data<<ccnt);
    }
}

unsigned char *contraste(void) ;

asm("	contraste:
		move.w	%d0,-(%a7)
		move.w  #4,%d0
		trap    #9
		move.w (%a7)+,%d0
		rts"		) ;

void SPRITE_8(short x,short y,short h,unsigned char* sprite,unsigned char* sprite1,unsigned char* sprite2,void* dest1, void *dest2)	{
		if (x<-15 || x>159) return;
		if (y<1)	{
		sprite+=1-y;
		sprite1+=1-y;
		sprite2+=1-y;
		h-=1-y;
		y=1;
		}
		if (y+h>92) h-=(y+h-92);
		if (x<0)	{
		x=240+x;
		y--;
		}
 		if (h<0) return;

    register long           offset = (y<<5)-(y<<1)+((x>>3)&0x1e);
    register long           addr1 = (long)dest1+offset;
    register long           addr2 = (long)dest2+offset;
    register unsigned short cnt  = 24-(x&15);
    
    for (;h;h--,addr1+=30,addr2+=30)	{
    	//MASQUE
			*(long*)addr1&=~((long)(~(*sprite++)&0xff)<<cnt);
			*(long*)addr2&=~((long)(~(*sprite)&0xff)<<cnt);
			//AFFICHE
      *(long*)addr1|=(long)(*sprite1++)<<cnt;
      *(long*)addr2|=(long)(*sprite2++)<<cnt;
		}
}

void SPRITE_32(short x,short y,short h,unsigned long* sprite,unsigned long* sprite1,unsigned long* sprite2,void* dest1, void *dest2)	{
		if (x<-15 || x>159) return;
		if (y<1)	{
		sprite+=1-y;
		sprite1+=1-y;
		sprite2+=1-y;
		h-=1-y;
		y=1;
		}
		if (y+h>92) h-=(y+h-92);
		if (x<0)	{
		x=240+x;
		y--;
		}
 		if (h<0) return;

    register long           offset = (y<<5)-(y<<1)+((x>>3)&0x1e);
    register long           addr1 = (long)dest1+offset;
    register long           addr2 = (long)dest2+offset;
    register unsigned short cnt  = x&15;
    register unsigned short ccnt = 32-cnt;
    register unsigned long  data;
    
    for (;h;h--,addr1+=30,addr2+=30)	{
    	//MASQUE
      data=~(*sprite++);
      *(long*)addr1&=~(data>>cnt),*(long*)(addr1+4)&=~(data<<ccnt);
      *(long*)addr2&=~(data>>cnt),*(long*)(addr2+4)&=~(data<<ccnt);
			//AFFICHE
      data=*sprite1++;
      *(long*)addr1|=(data>>cnt),*(long*)(addr1+4)|=(data<<ccnt);
      data=*sprite2++;
      *(long*)addr2|=(data>>cnt),*(long*)(addr2+4)|=(data<<ccnt);
		}
}

void GrisSprite32_ET(short x,short y,short h,unsigned long* sprite,void* plan0, void *plan1) {
		if (x<-31 || x>159) return;
		if (y<10)	{
		sprite+=10-y;
		h-=10-y;
		y=10;
		}
		if (y+h>90) h-=(y+h-90);
		if (x<0)	{
		x=240+x;
		y--;
		}
		if (h<0) return;

    register long           offset = (y<<5)-(y<<1)+((x>>3)&0x1e);
    register long           addr1 = (long)plan0+offset;
    register long           addr2 = (long)plan1+offset;
    register unsigned short cnt  = x&15;
    register unsigned short ccnt = 32-cnt;
    register unsigned long  data;
    
    for (;h;h--,addr1+=30,addr2+=30) {
      data=~(*sprite++);
      *(long*)addr1&=~(data>>cnt),*(long*)(addr1+4)&=~(data<<ccnt);
      *(long*)addr2&=~(data>>cnt),*(long*)(addr2+4)&=~(data<<ccnt);
    }
}
